
from os import listdir
from os.path import isfile, join
import json

path_units="units/"
fname_unit_id_filename_rel = "id/gen_unit_id.txt"
fname_unit_categories = "id/gen_unit_categories.txt"
fname_unit_builders = "id/gen_unit_builders.json"

onlyfiles = [f for f in listdir(path_units) if isfile(join(path_units, f)) and f.endswith(".json")]


f_unit_id_filename_rel = open(fname_unit_id_filename_rel, 'w')
f_unit_categories = open(fname_unit_categories, 'w')
f_unit_builders = open(fname_unit_builders, 'w')
f_unit_builders.write("{\"list\":[" + "\n")

collected_errors = ""
used_ids=","
used_unit_type_names=","
for filename in onlyfiles :
    with open(path_units+filename) as f:
      print("processing:" + filename)
      data = json.load(f)
      specs=""
      races=""
      is_fact="N"
      is_tech="N"
      default_image=""
      default_image_imgcolumns="1"
      unit_cost="0"
      if 'unitStatSheet' in data: 
        if 'unit' in data['unitStatSheet']:
          if 'trnRaces' in data['unitStatSheet']['unit']:
            if data['unitStatSheet']['unit']['trnRaces'] is not None:
              races=str(data['unitStatSheet']['unit']['trnRaces']).replace("'", "").replace(" ", "").replace("[", "").replace("]", "")
          if 'trnSpecUnitActions' in data['unitStatSheet']['unit']:
            if data['unitStatSheet']['unit']['trnSpecUnitActions'] is not None:
              specs=str(data['unitStatSheet']['unit']['trnSpecUnitActions']).replace("'", "").replace(" ", "").replace("[", "").replace("]", "")
          if 'isTechnology' in data['unitStatSheet']['unit']:  
            if data['unitStatSheet']['unit']['isTechnology']==True:
              is_tech="Y"
          if 'isFactory' in data['unitStatSheet']['unit']:  
            if data['unitStatSheet']['unit']['isFactory']==True:
              is_fact="Y"
          if 'costTurn' in data['unitStatSheet']['unit']:      
            unit_cost=str(data['unitStatSheet']['unit']['costTurn'])
      if 'uiDefinition' in data:
        if 'visuals' in data['uiDefinition']:
          if len(data['uiDefinition']['visuals'])>0:
            if 'imgName' in data['uiDefinition']['visuals'][0]:
              default_image = data['uiDefinition']['visuals'][0]['imgName']
              if data['uiDefinition']['visuals'][0]['type'] != "DEFAULT":
                collected_errors = collected_errors + "ERROR: 0th visual is not default:" + filename + "\n"
              default_image_imgcolumns = str(data['uiDefinition']['visuals'][0]['imgColumns'])
      unit_typeid=str(data['unitType'])
      unit_typename=data['unitTypeName']
      if ","+unit_typeid+"," in used_ids:
        collected_errors = collected_errors + "duplicate id:" + unit_typeid + "\n"
      else:
        used_ids=used_ids+unit_typeid+","
      if ","+unit_typename+"," in used_unit_type_names:        
        collected_errors = collected_errors + "duplicate type name:" + unit_typename + "\n"
      else:
        used_unit_type_names=used_unit_type_names+unit_typename+","        
      f_unit_id_filename_rel.write( unit_typeid + "|" +  unit_typename  + "|" + filename  + "|" + unit_cost + "|"  + default_image + "|" + default_image_imgcolumns + "|"  + specs + "|" + races +  "|" + is_tech + "|" + is_fact + ";" + "\n")
      if 'unitStatSheet' in data: 
        if 'unit' in data['unitStatSheet']: 
          if 'trnCategories' in data['unitStatSheet']['unit']: 
            if data['unitStatSheet']['unit']['trnCategories'] is not None: 
              if str(data['unitStatSheet']['unit']['trnCategories']) != '[]': 
                f_unit_categories.write(data['unitTypeName'] + ":" + str(data['unitStatSheet']['unit']['trnCategories']) + ";" + "\n")
          if 'trnBuilders' in data['unitStatSheet']['unit']: 
            if data['unitStatSheet']['unit']['trnBuilders'] is not None: 
              if str(data['unitStatSheet']['unit']['trnBuilders']) != '[]': 
                if str(data['unitStatSheet']['unit']['trnBuilders']) != '{}': 
                  f_unit_builders.write("{\"unitIdString\":" + "\""  + data['unitTypeName'] + "\"," + "\"trnBuilders\":" + str(data['unitStatSheet']['unit']['trnBuilders']).replace("'", "\"") + "}")
                  if filename == onlyfiles[-1]:
                    f_unit_builders.write("\n")
                  else:
                    f_unit_builders.write("," + "\n")
                  

f_unit_builders.write("]}" + "\n")
      
print(fname_unit_id_filename_rel + " written\n")
print(fname_unit_categories + " written\n")
print(fname_unit_builders + " written\n")

print("Errors:\n" + collected_errors)
input("Press Enter to continue...")



